### CHAPITRE 3 : INTRODUCTION TO R

## creating objects 

weight_kg <- 55

## naming variables 

weight_kg <- 55    # doesn't print anything
(weight_kg <- 55)  # but putting parenthesis around the call prints the value of `weight_kg`

# now that R has that variable in memory, we can add it to new codes

2.2*weight_kg

# if we assign a new value for weight_kg, it will change

weight_kg <- 67
weight_kg # the old value is now gone

##functions and their arguments 

b <- sqrt(10)
b

round(3,1415) #when using this function, it round to the nearest whole number
args(round) #the function args help us to know how to use a function
round(3.1414, digits = 2) #we asked R to put 2 numbers after the digits 
round(3.1415, 2) # its the same, we dont have to actually write "digits"

## vectors and data types 

#we can assign a serie of values to a vector using "c"

weight_g <- c(50, 60, 65, 82) #with numbers
weight_g

molecules <- c("dna", "rna", "protein") #with character we need "..."
molecules

length(weight_g) #to know how many values is in there 
class(weight_g) # to see if whether it is numeric or character 
str(weight_g) # with str we can see an overview of the structure of an object

#we can use "c" to add other values to our vector 

weight_g <- c(weight_g, 90) # add to the end of the vector
weight_g <- c(30, weight_g) # add to the beginning of the vector
weight_g

##subsetting vectors

molecules <- c("dna", "rna", "peptide", "protein")
molecules[2] # to only see the 2nd value of the vector

molecules[c(3, 2)] #to see more than just one value

more_molecules <- molecules[c(1, 2, 3, 2, 1, 4)] #to add with more elements
more_molecules

#we can also remove some values
molecules[-1] ## all but the first one
molecules[-c(1, 3)] ## all but 1st/3rd ones

## conditionnal subsetting

weight_g <- c(21, 34, 39, 54, 55)
weight_g[c(TRUE, FALSE, TRUE, TRUE, FALSE)]
#only the TRUE values will be returned (21, 39, 54) 

#but normally these are not write by hand, 
weight_g > 50 #only values higher than 50 will be returned 

# so we can use this to select only the values above 50
weight_g[weight_g > 50]

#we can also combine conditions 
weight_g[weight_g < 30 | weight_g > 50]
#[] = alt+maj+5
# | = alt+maj+l means at least one conditions has to be true 
# & means we want both conditions to be true 
weight_g[weight_g < 30 & weight_g > 50] #-> no values are true for both conditions

#search for certain strings in a vector with %in% 
molecules <- c("dan", "rna", "protein", "peptide")
molecules[molecules == "rna" | molecules == "dna"] # returns both rna and dna

molecules %in% c("rna", "dna", "metabolite", "peptide", "glycerol")
#we can see which of values from molecules are being in this new list 
molecules[molecules %in% c("rna", "dna", "metabolite", "peptide", "glycerol")]
#if we want to see the values directly 

##Names

x <- c(1, 5, 3, 5, 10)
names(x) ## no names

names(x) <- c("A", "B", "C", "D", "E")
names(x) ## now we have names

head(x) # we can see both names and values 

x[c(1, 3)]
x[c("A", "C")] #access elements by their names 

##Missing datas

heights <- c(2, 4, 4, NA, 6)
mean(heights)
#it returns "NA" bc one value is "NA", so we need to ask r to dont take into account NAs
mean(heights, na.rm = TRUE)
max(heights, na.rm = TRUE)

# Extract those elements which are not missing values.
heights[!is.na(heights)]
na.omit(heights)
heights[complete.cases(heights)]

#QUESTIONS
#1 Using this vector of heights in inches, create a new vector with the NAs removed.
heights <- c(63, 69, 60, 65, NA, 68, 61, 70, 61, 59, 64, 69, 63, 63, NA, 72, 65, 64, 70, 63, 65)
heights2 <- heights[!is.na(heights)]
# 2 calculate median
median(heights2)
# 3 how many are taller than 67
more_than_67<- heights2[heights2>67]
length(more_than_67)

##generating vectors

numeric(3)
#by default, its only ZERO
character(2)
# by default, character is empty 

#replicates functions
rep(-1,5) #we replic 5 times "-1"
rep(NA,5) #we replicate 5 times "NA"
rep(c(1,2,3),3)#we replicate 3 times "1, 2, 3"

#QUESTIONS
#repeat the values 1, 2 and 3  5times, but obtain five 1s, five 2s and five 3s in that order
#different ways to do it
?rep
?sort #it will sort the values en ordre croissant
rep(1:3, each=5)
rep(c(1, 2, 3), each = 5)
sort(rep(c(1, 2, 3), 5))

#sqc generation
seq(from = 1, to = 20, by = 2)
seq(1, 5, 1)
seq(1,5) #by default, "by=" vaut 1 if we don't write it in our functions
1:5 #is another form to make a generation

seq(from = 1, to = 20, length.out = 3) #we only want 3 values

#random samples and permutations
sample(1:10) #permute numbers in a random order
sample(letters,5) #give 5 random letters
sample(1:5, 10, replace=TRUE) #if we want values to be eventually repeated 

#QUESTION
#1  random permutations of 1:10 
sample(1:10) #always in a different order
#2 set.seed(123) and repeat the random draw
set.seed(123)
sample(1:10)
set.seed(123)
sample(1:10) # with set.seed() its always the same sample after

#rnorm
#rnorm(n,mean,sd)
rnorm(5, 2, 2)
rnorm(5,100,5)

##ADDITIONAL EXERCICES 

#QUESTION1 
# create vectors x and y 1 to 10 and 10 to 1
x <- 1:10
y <- 10:1

#types ?
class(x)
class(y) #theyre both integers

#sum of each? identical ?

sumx<- sum(x)
sumy <- sum(y)
identical(sumx,sumy) #its true so sum of x and y are the same

#swap values of x and y 
y2 <- y
y <- x
x <- y2
x
y #i swapped x and y valus 

#QUESTION2
# vector x with number 20 to 2, retrieve (=recup) elements larger than 5 or equal to 15 

x <- (20:2)
x[x>5 | x<=15 ]

#remove the fisrt 8 elemnts from x and store in x2

x2 <- x[-c(1:8)]
x2

#QUESTION3 : counting from Monday to Friday how many molds you see in your cell cultures.
#vector "molds" with results 1, 2 , 5, 8, 10

molds <- c(1,2,5,8,10)
names(molds) <- c("monday","tuesday","wednesday","thursday","friday")

#extract the number of molds identified on Wednesday.
molds["wednesday"]

#QUESTION4
# mean of a random distribution N(15, 1) of size 100 and store it in variable m1
m1<- sample(15:1, 100, replace=TRUE)
mm1<- mean(m1)

#mean of a random distribution N(0, 1) of size 100 and store it in variable m2
m2 <- sample(0:1, 100, replace=TRUE)
mm2 <- mean(m2)  

#mean of another random distribution N(15, 1) of size 1000 and store it in variable m3
m3 <- sample(15:1, 1000, replace= TRUE)
mm3 <- mean(m3)  

#which one of m1 and m2 will be larger
mm1>mm2 #TRUE so mm1 is larger than mm2

#QUESTION5
# simulate a set of 100 students voting (randomly) for 1, 2 or 3
std <- sample(1:3, 100, replace=TRUE) 

#values as a table 
table(std) 

#number of stds with more than 1
#? 
  
#QUESTION6, given vectors 
v1 <- c(1, 2, 3, "4")
v2 <- c(45, 23, TRUE, 21, 12, 34)
v3 <- c(v1, v2)

#
class(v3)
length(v3)
names(v3) <- c(letters[1:10])
v3

# create v4 containing "2"   "1"   "NEW" "3"   "4" with v1
v4 <- c("2","1","NEW","3","4")
v4

#round pi o 2 decimals
round(pi, digits = 2)

#QUESTION7
p1 <- c(1, 1, 1)
names(p1) <- c("A34", "D3", "F12")
p2 <- c(2, 2, 2, 2)
names(p2) <- c("W4", "A21", "K7", "K8")
p3 <- c(3, 3, 3, 3, 3, 3, 3)
names(p3) <- c("D1", "D2", "A10", "D5", "D15", "A16", "B22")

# command would you use to identify the number of respective answers
length(p1)
length(p2)
length(p3)

#Concatenate all answers into a single vector p4.
p4 <- c(p1,p2,p3)
p4

#get the vote for student D2 from vector p4
p4["D2"]

#QUESTION8

test <- c(student1 = 12, student2 = 11, student3 = 4, student4 = 6, student5 = 7,
  student6 = 8.5, student7 = 13.5, student8 = 5.5, student9 = 13.5,
  student10 = 2.5, student11 = 17, student12 = 18, student13 = 15,
  student14 = 8, student15 = 7, student16 = 12, student17 = 18.5,
  student18 = 7.5, student19 = 13.5, student20 = 6, student21 = 9,
  student22 = 16, student23 = 8.5, student24 = 9, student25 = NA,
  student26 = NA, student27 = 14, student28 = 16.5, student29 = 12,
  student30 = NA, student31 = 12.5, student32 = 3, student33 = NA,
  student34 = 17, student35 = 16, student36 = 9, student37 = 6,
  student38 = 7, student39 = 8.5, student40 = 8.5, student41 = 8,
  student42 = 16.5, student43 = 4.5, student44 = NA, student45 = 8,
  student46 = 8, student47 = 7.5, student48 = 8.5, student49 = 2,
  student50 = 14, student51 = 6.5, student52 = 12, student53 = 16.5,
  student54 = 7, student55 = 9.5, student56 = 12, student57 = 8.5,
  student58 = 15.5, student59 = 9, student60 = 13.5, student61 = 18,
  student62 = 12.5, student63 = 19.5, student64 = 13, student65 = 17.5,
  student66 = 8.5, student67 = 9, student68 = 7, student69 = 12.5,
  student70 = NA, student71 = 19, student72 = 11.5, student73 = 9,
  student74 = 9.5, student75 = 12, student76 = 11, student77 = 12,
  student78 = 14, student79 = 17, student80 = 8.5, student81 = 10,
  student82 = 10, student83 = NA, student84 = 10.5, student85 = 14,
  student86 = 7.5, student87 = 4, student88 = 9, student89 = 6.5,
  student90 = 10.5, student91 = 9.5, student92 = 13, student93 = 11.5,
  student94 = NA, student95 = 6, student96 = 12.5, student97 = 11.5,
  student98 = 4, student99 = 11.5, student100 = 8)

#number of students that have a mark > 10?

test1 <- test[!is.na(test)]
more_than_10 <- test1[test1>10]
length(more_than_10)

# number of students that have a mark greater than the average score

mean(test1)
more_than_avg <- test1[test1>10.6087]
length(more_than_avg)