## correction examen 2020

# 1 
library(rWSBIM1207)
library(tidyverse)
load_exam_data("30821800") 
x <- x30821800
x

length(rownames(x))
length(colnames(x))

#2 
x %>%
  as_tibble() %>%
  count(groups)

#3 
length(which(is.na(x)))
dim(x)

8240*13
100/107120*858

# 4 

x %>%
  as_tibble() %>% pivot_longer(names_to = "gene",
                               values_to = "gene_expression",
                               -c(groups, sample)) %>% group_by(sample) %>%
  summarise(is.na = length(which(is.na(gene_expression))))

# 5 

x %>%
  as_tibble() %>% pivot_longer(names_to = "gene",
                               values_to = "gene_expression",
                               -c(groups, sample)) %>% filter(gene == "gene_12", groups == "A") %>%
  summarise( m = mean(gene_expression, na.rm = TRUE))

# 6 

k2 <- fData(x) %>%
  arrange(p.value) %>%
  head(5)
k2
i <- order(fData(x)$p.value)[1:5]
k <- featureNames(x)[i]
k2$genes

# 7 
xk <- data.frame(x[k,])
xk

xk2 <- exprs(x[k,]) %>%
  data.frame() %>%
  mutate(gene = k) %>%
  pivot_longer(values_to = "expression",
               names_to="sample",
               1:14) %>%
  full_join(pdata(x))

#8 
library(ggplot2)
library(lubridate)

x <- read_csv(covid19_cases.csv())
y <- read_csv(covid19_deaths.csv())
z <- read_csv(covid19_recovered.csv())

cases <- x %>%
  filter(Country_Region=="Belgium") %>%
  pivot_longer(names_to = "Date",
               values_to = "cases", 
               -c(Province_State,Country_Region,Lat,Long))
  
deaths <- y %>%
  filter(Country_Region=="Belgium") %>%
  pivot_longer(names_to = "Date",
               values_to = "deaths", 
               -c(Province_State,Country_Region,Lat,Long))

recovered <- z %>%
  filter(Country_Region=="Belgium") %>%
  pivot_longer(names_to = "Date",
               values_to = "recovered", 
               -c(Province_State,Country_Region,Lat,Long))

full_join(cases,deaths) %>%
  full_join(recovered) %>%
  select(-c(Province_State,Lat,Long)) %>%
  pivot_longer(names_to = "Covid",
               values_to = "expression", 
               -c(Country_Region,Date))

full_join(cases,deaths) %>%
  full_join(recovered) %>%
  select(-c(Province_State,Lat,Long)) %>%
  pivot_longer(names_to = "Covid",
               values_to = "expression", 
               -c(Country_Region,Date)) %>%
  group_by(Date) %>%
  ggplot(aes(x= Date, 
         y = expression, 
         colour = Covid))+
  geom_point()+
  geom_vline(xintercept = c("3/13/20","5/4/2020","5/18/2020","6/8/2020"))
  

full_join(cases,deaths) %>%
  full_join(recovered) %>%
  select(-c(Province_State,Lat,Long)) %>%
  pivot_longer(names_to = "Covid",
               values_to = "expression", 
               -c(Country_Region,Date)) %>%
  mutate(Dates = mdy(Date))
  ggplot(aes(x= Dates, 
             y = expression, 
             colour = Covid))+
  geom_line()+
  geom_vline(xintercept = c(2020-03-18,2020-05-04,2020-05-18,2020-06-08))

#9 

cases <- x %>%
  filter(Country_Region=="Belgium") %>%
  pivot_longer(names_to = "date",
               values_to = "cases",
               -c(Province_State, Country_Region, Lat, Long)) %>%
  mutate(Date=mdy(date)) %>%
  select(Date,cases)

apple <- read_csv(apple_mobility.csv())  

apple %>%
  filter(region=="Belgium") %>%
  select(-c(geo_type,region,"sub-region",country,alternative_name)) %>%
  pivot_longer(names_to = "date",
               values_to = "number",
               -c(transportation_type)) %>%
  mutate(Date=ymd(date)) %>%
  select(Date,transportation_type,number)

full_join(cases,apple) %>%
  ggplot(aes(x=cases,
             y=number,
             colour=transportation_type))+
  geom_line()+
  scale_y_log10()
  



